// ------------ applicat.cpp

#include "dflatpp.h"

void Application::OpenWindow(MenuBarItem *menu)
{
    desktop.SetApplication(this);
    windowtype = ApplicationWindow;
    clearch = ClearChar;
    SetAttribute(BORDER | SAVESELF | CONTROLBOX | STATUSBAR);
    if (menu != 0)       {
        SetAttribute(MENUBAR);
        menubar = new MenuBar(menu, this);
    }
    else
        menubar = 0;
    statusbar = new StatusBar(this);
    desktop.mouse().Show();
    DFWindow::SetFocus();
    takingfocus = False;
}

void Application::CloseWindow()
{
    if (menubar != 0)
        delete menubar;
    if (statusbar != 0)
        delete statusbar;
    desktop.SetApplication(0);
    DFWindow::CloseWindow();
}

// -------- set the fg/bg colors for the window 
void Application::SetColors()
{
    colors.fg = 
    colors.sfg = 
    colors.ffg = 
    colors.hfg = LIGHTGRAY;
    colors.bg = 
    colors.sbg = 
    colors.fbg = 
    colors.hbg = BLUE;
}

void Application::AdjustBorders()
{
    DFWindow::AdjustBorders();
    if (attrib & MENUBAR)
        TopBorderAdj++;
    if (attrib & STATUSBAR)
        BottomBorderAdj = 1;
}

Bool Application::SetFocus()
{
    takingfocus = True;
    DFWindow::SetFocus();
    takingfocus = False;
    return True;
}

void Application::Show()
{
    if (!takingfocus || !isVisible())
        DFWindow::Show();
    else
        Border();
}

void Application::Keyboard(int key)
{
	if (key == ' ')
		DFWindow::Keyboard(key);
    // ---- forward unprocessed keys to the menubar
    else if (menubar != 0)
        menubar->Keyboard(key);
}

void Application::ClockTick()
{
    if (statusbar != 0)
        statusbar->ClockTick();
}

void Application::StatusMessage(String& Msg)
{
    if (statusbar != 0)
        statusbar->StatusMessage(Msg);
}

void Application::Execute(void)
{
    while (desktop.DispatchEvents())
        ;
}


