// -------------- applicat.h

#ifndef APPLICAT_H
#define APPLICAT_H

#include "menubar.h"
#include "statbar.h"

const int ClearChar = 176;

class Application : public DFWindow    {
    MenuBar *menubar;            // points to menu bar
    StatusBar *statusbar;        // points to status bar
    Bool takingfocus;            // true while taking focus
    virtual void SetColors();
    void OpenWindow(MenuBarItem *menu);
protected:
    // ------------- client window coordinate adjustments
    virtual void AdjustBorders();
public:
    Application(char *ttl, int lf, int tp, int ht, int wd,
                                    MenuBarItem *Menu = 0)
                : DFWindow(ttl, lf, tp, ht, wd, 0)
            { OpenWindow(Menu); }
    Application(char *ttl, int ht, int wd,
                                    MenuBarItem *Menu = 0)
                : DFWindow(ttl, ht, wd, 0)
            { OpenWindow(Menu); }
    Application(int lf, int tp, int ht, int wd,
                                    MenuBarItem *Menu = 0)
                : DFWindow(lf, tp, ht, wd, 0)
            { OpenWindow(Menu); }
    Application(int ht, int wd, MenuBarItem *Menu = 0)
                : DFWindow(ht, wd, 0)
            { OpenWindow(Menu); }
    Application(char *ttl, MenuBarItem *Menu = 0)
                : DFWindow(ttl)
            { OpenWindow(Menu); }
    virtual ~Application() {}
    // -------- API messages
    virtual void CloseWindow();
    virtual Bool SetFocus();
    virtual void Show();
    virtual void Keyboard(int key);
    virtual void ClockTick();
    void StatusMessage(String& Msg);
	void Execute();
};

#endif


