// ------------ control.cpp

#include "control.h"
#include "desktop.h"

unsigned Control::LatestShortcut;

void Control::OpenControl()
{
	Enable();
	shortcut = LatestShortcut;
	LatestShortcut = 0;
	if (Parent() == 0)	{
		SetParent((DFWindow *) ThisDialog);
	    Enqueue();
	}
	if (Parent())
		// --- x/y is relative to parent
		ChangePosition(Left() + Parent()->Left(),
						Top() + Parent()->Top());
}

void Control::Keyboard(int key)
{
    switch (key)    {
        case '\t':
			key = ALT_F6;
        default:
            DFWindow::Keyboard(key);
            break;
    }
}

Bool Control::SetFocus()
{
	if (isEnabled())	{
		DFWindow::SetFocus();
		return True;
	}
	return False;
}

void Control::ShortcutSelect()
{
	SetFocus();
}

void Control::Select()
{
	if (Parent())
		Parent()->ControlSelected((DFWindow *)this);
}

void Control::Choose()
{
	if (Parent())
		Parent()->ControlChosen((DFWindow *)this);
}


