/*-------------------------------------------------------------*\
 * (c) Copyright 1992 By Paul L. Yao.  All rights reserved.    *
\*-------------------------------------------------------------*/

/*-------------------------------------------------------------*\
 | MIN.CPP  A Minimum C++ Windows Program.  MIN displays a     |
 |          window which can be moved, sized, minimized and    |
 |          maximized.                                         |
\*-------------------------------------------------------------*/
#include <owl.h>

/*-------------------------------------------------------------*\
 |                    Class Declarations.                      |
\*-------------------------------------------------------------*/
class TMinApplication : public TApplication
  {
  public:
    TMinApplication (LPSTR lpszName, HANDLE hInstance,
                     HANDLE hPrevInstance, LPSTR lpszCmdLine,
                     int nCmdShow);
    virtual void InitMainWindow ();
  };

class TMinWindow : public TWindow
  {
  public:
    TMinWindow (PTWindowsObject pwParent, LPSTR lpszTitle,
                PTModule pmModule);
    virtual LPSTR GetClassName ();
    virtual void  GetWindowClass (WNDCLASS&);
  };

/*-------------------------------------------------------------*\
 |                 Main Function:  WinMain.                    |
\*-------------------------------------------------------------*/
int PASCAL WinMain (HANDLE hInstance,   HANDLE hPrevInstance,
                    LPSTR  lpszCmdLine, int    nCmdShow)
    {
    TMinApplication Min ("MIN", hInstance, hPrevInstance,
                         lpszCmdLine, nCmdShow);
    Min.Run();
    return Min.Status;
    }

/*-------------------------------------------------------------*\
 |                  Application Class Member.                  |
\*-------------------------------------------------------------*/
TMinApplication::TMinApplication (LPSTR lpszName, HANDLE hInstance,
                    HANDLE hPrevInstance, LPSTR lpszCmdLine,
                    int nCmdShow)
                :TApplication (lpszName, hInstance, hPrevInstance,
                    lpszCmdLine, nCmdShow)
    {
    /*  Application specific initialization goes here.  */
    }

/*-------------------------------------------------------------*\
 |                  Application Class Member.                  |
\*-------------------------------------------------------------*/
void TMinApplication::InitMainWindow ()
    {
    MainWindow = new TMinWindow (NULL, "Minimum", NULL);
    }

/*-------------------------------------------------------------*\
 |                   TMinWindow Class Member.                  |
\*-------------------------------------------------------------*/
TMinWindow::TMinWindow (PTWindowsObject pwParent,
               LPSTR lpszTitle, PTModule pmModule)
           :TWindow (pwParent, lpszTitle, pmModule)
    {
    /*  Window specific initialization goes here.  */
    }

/*-------------------------------------------------------------*\
 |                   TMinWindow Class Member.                  |
\*-------------------------------------------------------------*/
LPSTR TMinWindow::GetClassName ()
    {
    return "MIN:MAIN";
    }

/*-------------------------------------------------------------*\
 |                   TMinWindow Class Member.                  |
\*-------------------------------------------------------------*/
void TMinWindow::GetWindowClass (WNDCLASS& wc)
    {
    TWindow::GetWindowClass (wc);
    wc.hIcon=LoadIcon (wc.hInstance, "snapshot");
    wc.hCursor=LoadCursor (wc.hInstance, "hand");
    }
