/*  mouse interface  */

#include <stdio.h>
#include <conio.h>
#include <dos.h>

void mousecoords( int *x, int *y );
int mouseldblclicked(void);
int  mouselpressed(void);
int  mouserpressed(void);
int  mouselreleased(void);
int  mouserreleased(void);
int  mouseinit(void);
void mousegetbpressinfo( int *status, int *count, int button );
void mousegetbrelinfo( int *status, int *count, int button );
void mouseshow(void);
void mousehide(void);
void mousesetposition( int x, int y );
void mousereset(void);


void mousereset(void)
{
   struct REGPACK mouse;

   mouse.r_ax = 0x0021;
   mouse.r_bx = 0;
   mouse.r_cx = 0;
   mouse.r_dx = 0;
   mouse.r_si = 0;
   mouse.r_di = 0;
   mouse.r_ds = 0;
   mouse.r_es = 0;
   intr( 0x33, &mouse );
}

int mouseldblclicked(void)
{
     int status, count, elapsed=0;

     mousegetbpressinfo( &status, &count, 0 );

     if ((status & 0x0001)==0x0001)
     {
	while (!mouselreleased());
	while (elapsed++<10000 && !mouselpressed());
     }
     else return 0;
     if (elapsed>9999) return 0;
     else
	return 1;
}

int mouserdblclicked(void)
{
     int status, count, elapsed=0;

     mousegetbpressinfo( &status, &count, 1 );

     if ((status & 0x0002)==0x0002)
     {
	while (!mouserreleased());
	while (elapsed++<10000 && !mouserpressed());
     }
     else return 0;
     if (elapsed>9999) return 0;
     else
	return 1;
}

int mouselpressed(void)
{
     int status, count;

     mousegetbpressinfo( &status, &count, 0 );
     if ((status & 0x0001)==0x0001)
	return 1;
     else
	return 0;
}

int mouselreleased(void)
{
     int status, count;

     mousegetbrelinfo( &status, &count, 0 );
     if ( ((status & 0x0001)==0x0000) && (count>0))
	return 1;
     else
	return 0;
}

int mouserpressed(void)
{
     int status, count;

     mousegetbpressinfo( &status, &count, 1 );
     if ((status & 0x0002)==0x0002)
	return 1;
     else
	return 0;
}

int mouserreleased(void)
{
     int status, count;

     mousegetbrelinfo( &status, &count, 1 );
     if ( ((status & 0x0002)==0x0000) && (count>0))
	return 1;
     else
	return 0;
}

int mouseinit(void)
{
   struct REGPACK mouse;

   mouse.r_ax = 0;
   mouse.r_bx = 0;
   mouse.r_cx = 0;
   mouse.r_dx = 0;
   mouse.r_si = 0;
   mouse.r_di = 0;
   mouse.r_ds = 0;
   mouse.r_es = 0;
   intr( 0x33, &mouse );
   if (mouse.r_ax!=0) return 1;
   else return 0;
}


void mouseshow(void)
{
   struct REGPACK mouse;

   mouse.r_ax = 1;
   mouse.r_bx = 0;
   mouse.r_cx = 0;
   mouse.r_dx = 0;
   mouse.r_si = 0;
   mouse.r_di = 0;
   mouse.r_ds = 0;
   mouse.r_es = 0;
   intr( 0x33, &mouse );
}

void mousehide(void)
{
   struct REGPACK mouse;

   mouse.r_ax = 2;
   mouse.r_bx = 0;
   mouse.r_cx = 0;
   mouse.r_dx = 0;
   mouse.r_si = 0;
   mouse.r_di = 0;
   mouse.r_ds = 0;
   mouse.r_es = 0;
   intr( 0x33, &mouse );
}

void mousecoords(int *x, int *y)
{
   struct REGPACK mouse;

   mouse.r_ax = 3;
   mouse.r_bx = 0;
   mouse.r_cx = 0;
   mouse.r_dx = 0;
   mouse.r_si = 0;
   mouse.r_di = 0;
   mouse.r_ds = 0;
   mouse.r_es = 0;
   intr( 0x33, &mouse );
   *x = mouse.r_cx;
   *y = mouse.r_dx;
}

void mousesetposition( int x, int y )
{
   struct REGPACK mouse;

   mouse.r_ax = 4;
   mouse.r_bx = 0;
   mouse.r_cx = x;
   mouse.r_dx = y;
   mouse.r_si = 0;
   mouse.r_di = 0;
   mouse.r_ds = 0;
   mouse.r_es = 0;
   intr( 0x33, &mouse );
}

void mousegetbpressinfo( int *status, int *count, int button )
{
   struct REGPACK mouse;

   mouse.r_ax = 5;
   mouse.r_bx = button;
   mouse.r_cx = 0;
   mouse.r_dx = 0;
   mouse.r_si = 0;
   mouse.r_di = 0;
   mouse.r_ds = 0;
   mouse.r_es = 0;
   intr( 0x33, &mouse );
   *status = mouse.r_ax;
   *count = mouse.r_bx;
}

void mousegetbrelinfo( int *status, int *count, int button )
{
   struct REGPACK mouse;

   mouse.r_ax = 6;
   mouse.r_bx = button;
   mouse.r_cx = 0;
   mouse.r_dx = 0;
   mouse.r_si = 0;
   mouse.r_di = 0;
   mouse.r_ds = 0;
   mouse.r_es = 0;
   intr( 0x33, &mouse );
   *status = mouse.r_ax;
   *count = mouse.r_bx;
}


