// ----------- pbutton.h

#ifndef PBUTTON_H
#define PBUTTON_H

#include "textbox.h"

class PushButton : public TextBox    {
    virtual void SetColors();
    Bool pressed;
    DFWindow *owner;  // window that gets the command
    void (DFWindow::*cmdfunction)();    // selection function
public:
    PushButton(char *lbl, int lf, int tp, DFWindow *par=0);
    virtual ~PushButton() {}
    // -------- API messages
    virtual void CloseWindow();
    virtual Bool SetFocus();
    virtual void ResetFocus();
    virtual void Paint();
    virtual void Shadow();
    virtual void Keyboard(int key);
    virtual void LeftButton(int mx, int my);
    virtual void ButtonReleased(int mx, int my);
    virtual void MouseMoved(int mx, int my);
    virtual void KeyReleased();
    virtual void PressButton();
    virtual void ReleaseButton();
    virtual void ButtonCommand();
	virtual void ShortcutSelect();
    void SetButtonFunction(DFWindow *wnd,
                    void (DFWindow::*cmdfunc)())
        { owner = wnd; cmdfunction = cmdfunc; }
};

class OKButton : public PushButton	{
public:
	OKButton(int x, int y) : PushButton("  ~Ok  ", x, y)
		{ SetButtonFunction((DFWindow *)ThisDialog,
				&DFWindow::OKFunction); }
};

class CancelButton : public PushButton	{
public:
	CancelButton(int x, int y) : PushButton("~Cancel", x, y)
		{ SetButtonFunction((DFWindow *)ThisDialog,
				&DFWindow::CancelFunction); }
};

class YesButton : public PushButton	{
public:
	YesButton(int x, int y) : PushButton(" ~Yes ", x, y)
		{ SetButtonFunction((DFWindow *)ThisDialog,
				&DFWindow::OKFunction); }
};

class NoButton : public PushButton	{
public:
	NoButton(int x, int y) : PushButton(" ~No  ", x, y)
		{ SetButtonFunction((DFWindow *)ThisDialog,
				&DFWindow::CancelFunction); }
};

class HelpButton : public PushButton	{
public:
	HelpButton(int x, int y) : PushButton(" ~Help ", x, y)
		{ SetButtonFunction((DFWindow *)ThisDialog,
				&DFWindow::HelpFunction); }
};

#endif


