// --------- video.h

#ifndef VIDEO_H
#define VIDEO_H

#include "rectangl.h"

extern unsigned video_mode;
extern unsigned video_page;
extern unsigned char ScreenHeight;
extern unsigned char ScreenWidth;

void initvideo(void);
void restorevideo(void);
Bool isEGA(void);
Bool isVGA(void);
void Set25(void);
void Set43(void);
void Set50(void);
void scroll_window(Rect &, int, int, int);
unsigned int GetVideoChar(int, int);
void PutVideoChar(int, int, int);
void WriteVideoString(char *, int, int, int, int);
void get_videomode(void);
void storevideo(Rect &, char *);
void getvideo(Rect &, char *);
void swapvideo(Rect &, char *, Bool, Bool, Bool);

inline int clr(int fg, int bg)
{
	return fg | (bg << 4);
}

inline unsigned vad(int x, int y)
{
	return y * (ScreenWidth * 2) + x * 2;
}

inline Bool ismono()
{
	return (Bool) (video_mode == 7);
}

inline Bool istext()
{
	return (Bool) (video_mode < 4);
}

const int VIDEO = 0x10;

#endif

